/*
 * This program demonstrates the use of the map class.
 */

#include <iostream>
#include <fstream>
#include <map>
#include <algorithm>
#include <string>
using namespace std;

/*
 * Reads the given input file and produces a map of tallies of the form
 * {word => number of occurrences of that word in the file}.
 * Prints the most common word and its count.
 */
void wordTally(string filename) {
    // read the words of the file into a map of {word => occurrences of it}
    map<string, int> wordCounts;
    string champion;
    int max = 0;
    ifstream input;
    input.open(filename.c_str());
    while(true) {
        string word;
        input >> word;
        if (input.fail()) {
            break;
        }
        transform(word.begin(), word.end(), word.begin(), ::tolower);
        wordCounts[word]++;
        if (wordCounts[word] > max) {
            max = wordCounts[word];
            champion = word;
        }
    }

    cout << "The most common word in " << filename << " is: \"" << champion << "\" which occurs " << max << " times" << endl;
}

int main() {
    wordTally("shakespeare.txt");
    return 0;
}
